require 'test_helper'

class TestDealer < Test::Unit::TestCase
	def setup
		@dealer = Ventiuna::Dealer.new("TestDealer")

		@duce = Ventiuna::Card.new(rank: "2", suit: "club")
		@tres = Ventiuna::Card.new(rank: "3", suit: "diamond")
		@quatro = Ventiuna::Card.new(rank: "4", suit: "heart")
		@cinco = Ventiuna::Card.new(rank: "5", suit: "diamond")
		@seis = Ventiuna::Card.new(rank: "6", suit: "heart")

		@seven_of_diamonds = Ventiuna::Card.new(rank: "7", suit: "diamond")
		@eight_of_spades = Ventiuna::Card.new(rank: "8", suit: "spade")
		@eight_of_clubs = Ventiuna::Card.new(rank: "8", suit: "club")
		@nine_of_spades = Ventiuna::Card.new(rank: "9", suit: "spade")
		@ten_of_clubs = Ventiuna::Card.new(rank: "10", suit: "club")

		@jack_of_clubs = Ventiuna::Card.new(rank: "J", suit: "club")
		@king_of_hearts = Ventiuna::Card.new(rank: "K", suit: "heart")
		@ace_of_diamonds = Ventiuna::Card.new(rank: "A", suit: "diamond")
		@ace_of_spades = Ventiuna::Card.new(rank: "A", suit: "spade")
		@ace_of_clubs = Ventiuna::Card.new(rank: "A", suit: "club")
	end

	def test_hit_up_to_17
		@dealer.hand << @duce
		@dealer.hand << @duce
		assert_equal("h", @dealer.decision)
		@dealer.reset_hand

		@dealer.hand << @duce
		@dealer.hand << @tres
		assert_equal("h", @dealer.decision)
		@dealer.reset_hand

		@dealer.hand << @duce
		@dealer.hand << @quatro
		assert_equal("h", @dealer.decision)
		@dealer.reset_hand

		@dealer.hand << @duce
		@dealer.hand << @cinco
		assert_equal("h", @dealer.decision)
		@dealer.reset_hand

		@dealer.hand << @duce
		@dealer.hand << @seis
		assert_equal("h", @dealer.decision)
		@dealer.reset_hand

		@dealer.hand << @duce
		@dealer.hand << @seven_of_diamonds
		assert_equal("h", @dealer.decision)
		@dealer.reset_hand

		@dealer.hand << @duce
		@dealer.hand << @eight_of_clubs
		assert_equal("h", @dealer.decision)
		@dealer.reset_hand

		@dealer.hand << @duce
		@dealer.hand << @nine_of_spades
		assert_equal("h", @dealer.decision)
		@dealer.reset_hand

		@dealer.hand << @duce
		@dealer.hand << @ten_of_clubs
		assert_equal("h", @dealer.decision)
		@dealer.reset_hand

		@dealer.hand << @tres
		@dealer.hand << @ten_of_clubs
		assert_equal("h", @dealer.decision)
		@dealer.reset_hand

		@dealer.hand << @quatro
		@dealer.hand << @ten_of_clubs
		assert_equal("h", @dealer.decision)
		@dealer.reset_hand

		@dealer.hand << @cinco
		@dealer.hand << @ten_of_clubs
		assert_equal("h", @dealer.decision)
		@dealer.reset_hand

		@dealer.hand << @seis
		@dealer.hand << @ten_of_clubs
		assert_equal("h", @dealer.decision)
		@dealer.reset_hand

		@dealer.hand << @duce
		assert_equal("h", @dealer.decision)
		@dealer.hand << @tres
		assert_equal("h", @dealer.decision)
		@dealer.hand << @quatro
		assert_equal("h", @dealer.decision)
		@dealer.hand << @cinco
		assert_equal("h", @dealer.decision)
		@dealer.hand << @ace_of_spades
		assert_equal("h", @dealer.decision)
		@dealer.hand << @ace_of_diamonds
		assert_equal("h", @dealer.decision)
		@dealer.hand << @ace_of_clubs
		assert_equal("s", @dealer.decision)
		@dealer.reset_hand
	end

	def hit_on_soft_17
		@dealer.hand << @ace_of_diamonds
		@dealer.hand << @seis
		assert_equal("h", @dealer.decision)
		@dealer.reset_hand

		@dealer.hand << @ace_of_diamonds
		@dealer.hand << @duce
		@dealer.hand << @quatro
		assert_equal("h", @dealer.decision)
		@dealer.reset_hand		
	end

	def stand_on_17_and_up
		#17
		@dealer.hand << @nine_of_spades
		@dealer.hand << @eight_of_clubs
		assert_equal("s", @dealer.decision)
		@dealer.reset_hand

		#18
		@dealer.hand << @ace_of_diamonds
		@dealer.hand << @seven_of_diamonds
		assert_equal("s", @dealer.decision)
		@dealer.reset_hand

		#19
		@dealer.hand << @ace_of_diamonds
		@dealer.hand << @eight_of_clubs
		assert_equal("s", @dealer.decision)
		@dealer.reset_hand

		#20
		@dealer.hand << @ace_of_diamonds
		@dealer.hand << @nine_of_spades
		assert_equal("s", @dealer.decision)
		@dealer.reset_hand

		#21
		@dealer.hand << @ace_of_diamonds
		@dealer.hand << @jack_of_clubs
		assert_equal("s", @dealer.decision)
		@dealer.reset_hand
	end
end