require 'test_helper'

class TestDeck < Test::Unit::TestCase
	def test_init
		assert deck = Ventiuna::Deck.new
		assert_equal(52, deck.cards.size)
	end

	def test_shuffle
		deck = Ventiuna::Deck.new
		assert deck.shuffle

		assert Ventiuna::Deck.new.cards == Ventiuna::Deck.new.cards, "two unsuffled decks should matchn"

		# it's possible these two decks will be shuffled into the same order, but very unlikely
		deck1 = Ventiuna::Deck.new.shuffle
		deck2 = Ventiuna::Deck.new.shuffle
		assert deck1 != deck2, "two shuffled decks should not match"
	end

	def test_pop
		deck = Ventiuna::Deck.new.shuffle
		assert card = deck.pop
		assert card.class == Ventiuna::Card
		assert_equal(51, deck.size)
		
		card2 = deck.pop
		assert card != card2
		assert_equal(50, deck.size)

		deck = Ventiuna::Deck.new.shuffle
		52.times do
			card = deck.pop
			assert card.class == Ventiuna::Card
		end
		assert_nil deck.pop
		assert_equal(0, deck.size)
	end
end