require 'test_helper'

class TestPlayer < Test::Unit::TestCase
	def setup
		@player = Ventiuna::Player.new("Player1")
		@ace_of_spades = Ventiuna::Card.new(rank: "A", suit: "spade")
	end

	def test_init
		player = Ventiuna::Player.new("TestPlayer")
		assert_equal("TestPlayer", player.name)
		assert player.hands
		assert player.stats
		assert player.balance.kind_of?(Numeric)
	end

	def test_place_bet
		assert @player.place_bet(5, 1000).kind_of?(Numeric)
	end

	def test_active_hand
		assert @player.active_hand.kind_of?(Ventiuna::Hand)
		assert @player.hand.kind_of?(Ventiuna::Hand)
		assert_equal(@player.hand, @player.active_hand)
	end

	def test_reset_hand
		@player.active_hand << @ace_of_spades
		assert @player.active_hand.value != 0

		@player.reset_hand
		assert_equal(0, @player.hand.value)
	end

	def test_decision
		assert ["s", "h", "d", "sp"].include?(@player.decision(@ace_of_spades))
	end
end