require 'test_helper'

class TestShoe < Test::Unit::TestCase
	def test_init
		assert one_deck_shoe = Ventiuna::Shoe.new(1)

		two_deck_shoe = Ventiuna::Shoe.new(2)
		assert_equal(104, two_deck_shoe.cards.size)
	end

	def test_shuffle
		assert six_deck_shoe = Ventiuna::Shoe.new(6).shuffle
		assert_equal(312, six_deck_shoe.size)

		assert Ventiuna::Shoe.new(8).cards == Ventiuna::Shoe.new(8).cards, "two unsuffled shoes should match"

		shoe1 = Ventiuna::Shoe.new(8).shuffle
		shoe2 = Ventiuna::Shoe.new(8).shuffle
		assert shoe1 != shoe2, "two shuffled shoes should not match"
	end

	def test_pop
		eight_deck_shoe = Ventiuna::Shoe.new(8).shuffle
		assert_equal(416, eight_deck_shoe.size)
		assert eight_deck_shoe.pop.kind_of?(Ventiuna::Card)
		assert_equal(415, eight_deck_shoe.size)
	end

	def test_needs_shuffling?
		eight_deck_shoe = Ventiuna::Shoe.new(8)
		assert eight_deck_shoe.needs_shuffling?

		eight_deck_shoe.shuffle
		assert !eight_deck_shoe.needs_shuffling?

		eight_deck_shoe = Ventiuna::Shoe.new(8).shuffle
		104.times do
			eight_deck_shoe.pop
		end
		assert !eight_deck_shoe.needs_shuffling?

		eight_deck_shoe = Ventiuna::Shoe.new(8).shuffle
		312.times do
			eight_deck_shoe.pop
		end
		assert eight_deck_shoe.needs_shuffling?

		eight_deck_shoe = Ventiuna::Shoe.new(8).shuffle
		360.times do
			eight_deck_shoe.pop
		end
		assert eight_deck_shoe.needs_shuffling?
	end
end